
CON

  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000


var
byte buf[2400]
byte line_buf[640] ' 4 lines 2 line buffers
long color_buf[63] ' color buffer for lines


byte border_red
byte border_green
byte border_blue

byte back_red
byte back_green
byte back_blue

byte font_red
byte font_green
byte font_blue

long buf_ptr
long font_ptr

long line_buf_ptr
long color_buf_ptr

pub demo | random, i


font_red:=2
font_green:=3
font_blue:=3
back_red:=0
back_green:=1
back_blue:=2
border_red:=0
border_green:=0
border_blue:=1


repeat i from 0 to 2399
  buf[i]:=i&127

repeat i from 0 to 30
  code_colors(i)



start

random:=cnt

repeat
  waitcnt (cnt+80000000)

  repeat i from 0 to 30

    font_red:=random? & 3
    font_green:=random? & 3
    font_blue:=random? & 3
    back_red:=random? & 3
    back_green:=random? & 3
    back_blue:=random? & 3
    border_red:=random? & 3
    border_green:=random? & 3
    border_blue:=random? & 3

    code_colors(i)


pub code_colors(line) | tc, bord_color, font_color

bord_color:=border_red<<6+border_green<<4+border_blue<<2+3
bord_color:=bord_color<<24+bord_color<<16+bord_color<<8+bord_color

tc:=font_red<<6+font_green<<4+font_blue<<2+3
font_color:=back_red<<6+back_green<<4+back_blue<<2+3
font_color+=tc<<8
font_color+=font_color<<16
color_buf[2*line]:=bord_color
color_buf[2*line+1]:=font_color


pub start

buf_ptr:=@buf
line_buf_ptr:=@line_buf
font_ptr:=@st_font
color_buf_ptr:=@color_buf

cognew(@vga_start,@buf_ptr)
cognew(@cache_start,@buf_ptr)



dat
st_font                 file "st3font.def"


dat
vga_start               org               0


{*****************************************************************************************************************
Display cog. It displays pixels from scanline buffer. The buffer contains 8 scanlines
It is filled in real time with decoding cog/cogs. This structure allows to add anything
to the picture: text, lines, shapes, it have to be computed in real time with another cogs
******************************************************************************************************************}

init_vga                mov buffer_addr,par
                        add buffer_addr,#8
                        rdlong l_b_ptr,buffer_addr      '8 lines line buffer pointer
                        add buffer_addr,#4
                        rdlong c_b_ptra, buffer_addr    'color buffer
                        mov dira,pinmask                'vga pins as output
                        mov ctra,#0
                        movi ctra,#%0_00001_110         'pll div 2
                        mov frqa,frqa_val               '40 MHz pixel clock

                        mov vscl,vscl_val               'init video generator
                        mov vcfg,vcfg_val


'********************   Start of frame rendering *******************************

frame

                        mov l_count,#23                  '23 lines of back porch
bp_loop                 call #blank_line
                        djnz l_count,bp_loop

                        mov l_count,#60                  '60 lines of upper border
up_frm_loop             call #frame_line
                        djnz l_count,up_frm_loop

                        mov linenum, #0
                        mov l_count,#480                 '480 lines picture
line_loop               call #normal_line
                        djnz l_count,line_loop

                        mov l_count,#60                  '40 lines of lower frame
d_frm_loop              call #frame_line
                        djnz l_count,d_frm_loop
                                                         '1 line of front porch
fp_loop                 call #blank_line

                        mov l_count,#4                   '4 lines of vsync
vbl_loop                call #vsync_line
                        djnz l_count,vbl_loop

                        jmp  #frame

'********************   End of frame; start of subroutines **********************

'********************   Porches  ************************************************


blank_line              mov vscl,vscl_val_bp
                        waitvid blank_color,blank_pixels

                        mov vscl,vscl_val_lb                '800 pixels
                        waitvid blank_color,blank_pixels

                        mov vscl,vscl_val_fp
                        waitvid blank_color,blank_pixels

                        mov vscl,vscl_val_sync
                        waitvid hblk_color,blank_pixels

blank_line_ret          ret

'********************   Vsync   **************************************************

vsync_line              mov vscl,vscl_val_bp
                        waitvid vblank_color,blank_pixels

                        mov vscl,vscl_val_lb                '800 pixels
                        waitvid vblank_color,blank_pixels

                        mov vscl,vscl_val_fp
                        waitvid vblank_color,blank_pixels

                        mov vscl,vscl_val_sync
                        waitvid vhblk_color,blank_pixels

vsync_line_ret          ret

'********************   Borders   ****************************************************

frame_line              mov vscl,vscl_val_bp
                        waitvid blank_color,blank_pixels
                        mov vscl,vscl_val
                        mov linenum, #60
                        add linenum,c_b_ptra
                        mov c_b_ptr,linenum
                        rdlong border_color,linenum

                        mov vscl,vscl_val_lb                '800 pixels of border
fl2                     waitvid border_color,blank_pixels

                        mov vscl,vscl_val_fp
                        waitvid blank_color,blank_pixels

                        mov vscl,vscl_val_sync
                        waitvid hblk_color,blank_pixels

frame_line_ret          ret


'*******************    Standard picture line display *******************************


normal_line             mov linenum, #480
                        sub linenum,l_count                  'count line numbers from #0
'back porch
                        mov vscl,vscl_val_bp
                        waitvid blank_color,blank_pixels

                        shr linenum, #4                      'count color buffer offset
                        shl linenum, #3
                        add linenum,c_b_ptra
                        mov c_b_ptr,linenum
'left border
                        mov vscl,vscl_val_bord
                        waitvid border_color,blank_pixels

                        rdlong border_color,linenum          'read colors for line
                        add linenum,#4
                        rdlong std_colors,linenum

                        mov vscl,vscl_val

                        mov p_count,#20                      '640 pixels of picture
nl                      rdlong temp_buff,l_b_ptr             '20 longs to display
                        waitvid std_colors,temp_buff
                        add l_b_ptr,#4
                        djnz p_count,#nl
                        add t_cnt, #1                        'line buffer line counter
'right border
                        mov vscl,vscl_val_bord
                        waitvid border_color,blank_pixels


                        cmp t_cnt, #8           wz           'if 8 lines displayed,
                if_z    sub l_b_ptr,a640                     'restart display from beginning
'front porch
                        mov vscl,vscl_val_fp
                        waitvid blank_color,blank_pixels
'hsync
                        mov vscl,vscl_val_sync
                        waitvid hblk_color,blank_pixels

                        and t_cnt,#$07                      'don't let buffer line cnt to be >8
normal_line_ret         ret

'********************   variables *********************************************

l_count                 long    0
p_count                 long    0
frqa_val                long    $10000000       '40 Mhz pixel clock
vscl_val                long    $00001020       '1 clock/pixel, 32 clock/frame

vscl_val_sync           long    $00001080
vscl_val_bord           long    $00001050
vscl_val_fp             long    $00001058
vscl_val_bp             long    $00001028
vscl_val_lb             long    $00001320
vcfg_val                long    $200004ff       'video vga, 2 colors, 16..23

blank_color             long    $03030303       'high sync
hblk_color              long    $01010101       'hblk, hsync low
vhblk_color             long    0               'all sync low
vblank_color            long    $02020202       'vsync low
border_color            long    0
std_colors              long    0

blank_pixels            long    0
pinmask                 long    $00FF0000
buffer_addr             long    0
temp_buff               long    $00000000
b_col_ptr               long    0
std_col_ptr             long    0
font_b_ptr              long    0
t_cnt                   long    0
l_b_ptr                 long    0
a640                    long    640
hsyncmask               long    %00000000_00000010_00000000_00000000
vsyncmask               long    %00000000_00000001_00000000_00000000
l_b_ptra                long    0
c_b_ptra                long    0
linenum                 long    0
linenum2                long    0
c_b_ptr                 long    0

                        fit     496

dat
cache_start             org     0

{**********************************************************************************************************
 This is a decoding cog. It decodes 80 chars to 4 scan lines and fills scan line buffer for displaying cog.
 There is only a few free time when displaying lines, but this cog is still free when displying borders,
 porches and vsync
 **********************************************************************************************************}

'initialize pointers

                        mov buffer_addr2,par
                        rdlong m_b_ptr2,buffer_addr2        'main buffer
                        add buffer_addr2,#4
                        rdlong f_b_ptr2,buffer_addr2        'font definition buffer
                        add buffer_addr2,#4
                        rdlong l_b_ptr2,buffer_addr2        'scanline buffer

'wait for vsync


vsync                   waitpeq zero,vsyncmask2
                        waitpeq vsyncmask2,vsyncmask2

{waiting for 66 lines (porch plus border-4). When 4 scanlines are displaying, 4 next scanlines are preparing,
so preparation have to start 4 scanlines before main screen area starts displaying}

                        mov counter1,#79
loop1                   waitpeq zero,hsyncmask2
                        waitpeq hsyncmask2,hsyncmask2
                        djnz counter1,#loop1

{now decode 30 lines in sync with hblanks. One decode proceduer call decodes 4 scanlines, so we have
to call it 4 times}

                        mov counter2,#30

loop2                   call #decode
                        add l_b_ptr2,#240
                        sub m_b_ptr2,#80
                        add f_b_ptr2,#4
                        call #decode
                        sub l_b_ptr2,#400
                        sub m_b_ptr2,#80
                        add f_b_ptr2,#4
                        call #decode
                        add l_b_ptr2, #240
                        sub m_b_ptr2,#80
                        add f_b_ptr2,#4
                        call #decode
                        sub f_b_ptr2,#12
                        sub l_b_ptr2,#400
                        djnz counter2,#loop2
                        rdlong m_b_ptr2,par
                        jmp #vsync


decode                  mov counter1,#80
loop3                   rdbyte char,m_b_ptr2
                        shl char,#4
                        add char,f_b_ptr2
                        rdlong bytes, char
                        'nop
                        add m_b_ptr2,#1
                        wrbyte bytes,l_b_ptr2
                        add l_b_ptr2,#80
                        shr bytes,#8
                        wrbyte bytes,l_b_ptr2
                        add l_b_ptr2,#80
                        shr bytes,#8
                        wrbyte bytes,l_b_ptr2
                        add l_b_ptr2,#80
                        shr bytes,#8
                        wrbyte bytes,l_b_ptr2
                        sub l_b_ptr2,#239
                        djnz counter1,#loop3

                        waitpeq zero,hsyncmask2
                        waitpeq hsyncmask2,hsyncmask2
decode_ret              ret


zero                    long    0

l_b_ptr2                long    0
f_b_ptr2                long    0
m_b_ptr2                long    0

char                    long    0
bytes                   long    0

counter1                long    0
counter2                long    0

buffer_addr2            long    0
hsyncmask2              long    %00000000_00000010_00000000_00000000
vsyncmask2              long    %00000000_00000001_00000000_00000000

                        fit 496
